#include <QtSql/qsqlerror.h>
#include <QtSql/qsqlquery.h>
#include <QtSql/qsqldatabase.h>
#include <QtSql/qsqltablemodel.h>
#include <QtGui/QApplication>
#include <QtCore/qtimer.h>
#include <QtCore/qabstractitemmodel.h>
#include <QtCore/qnamespace.h>
#include <QtCore/qobjectdefs.h>
#include <QtCore/qvariant.h>
#include <QtCore/qstring.h>
#include <iostream>
#include <QtCore/qobject.h>
#include <QtCore/qvariant.h>
#include <stdlib.h>
#include <QtCore/QDebug>

class QSqlTableModelChild: public QSqlTableModel
{
public:
    QSqlTableModelChild
    (
            QObject * Par_1,
            QSqlDatabase Par_2
    );
    bool deleteRowFromTable_Adv(int Par_1);
};

QSqlDatabase create_QSqlDatabase_QSqlTableModel()
{
    QSqlDatabase Obj = QSqlDatabase::addDatabase("QSQLITE", "Sample");
    Obj.setDatabaseName("Sqlite3File.db");
    Obj.setHostName("localhost");
    Obj.open();
    return Obj;
}

//QSqlTableModelChild DEFINITION
QSqlTableModelChild::QSqlTableModelChild
(
    QObject * Par_1,
    QSqlDatabase Par_2
):QSqlTableModel(Par_1, Par_2){}

bool QSqlTableModelChild::deleteRowFromTable_Adv(int Par_1)
{
    return this->deleteRowFromTable(Par_1);
}

#define PAR_0 0

int main(int argc, char **argv)
{
    //COPY TEST DATA
    //createLocalTestData();

    //PREAMBLE
    #ifdef Q_WS_X11
    bool useGUI = getenv( "DISPLAY" ) != 0;
    #else
    bool useGUI = true;
    #endif
    int app_argc = 1;
    char* app_argv[2]={"", NULL};
    QApplication::setColorSpec(QApplication::ManyColor);
    QApplication* app = new QApplication(app_argc, app_argv, useGUI);

    //PARAMETER INITIALIZATION
    QSqlTableModelChild Obj(0, create_QSqlDatabase_QSqlTableModel());

    //INIT CODE
    Obj.setTable("user");
    Obj.setEditStrategy(QSqlTableModel::OnManualSubmit);
    Obj.select();

    //TARGET INTERFACE
    bool
    Return = Obj.deleteRowFromTable_Adv(PAR_0);

    //CHECK RETURN VALUE
    /*REQ("deleteRowFromTable.02",
    "CONSTRAINT FOR RETURN FAILED: '($0 == true)'",
    (Return == true));
    */
    Q_ASSERT(Return == true);

    //CHECK OBJECT VALUE
    /*
    REQ("deleteRowFromTable.01",
    "CONSTRAINT FOR OBJECT FAILED: '(!QSqlDatabase::isDriverAvailable(\"QSQLITE\"))||($0.submitAll() && $0.rowCount() == 2)'",
    (!QSqlDatabase::isDriverAvailable("QSQLITE"))||(Obj.submitAll() && Obj.rowCount() == 2));
    */
    Q_ASSERT(!QSqlDatabase::isDriverAvailable("QSQLITE")||(Obj.submitAll() && Obj.rowCount() == 2));

    //FINALIZATION
    QTimer::singleShot(100, app, SLOT(quit()));
    app->exec();

    return 0;
}
